Index: INSTALL
===================================================================
--- INSTALL	(revision 18250)
+++ INSTALL	(working copy)
@@ -142,13 +142,13 @@
   * Link to a blas/scalapack library that accelerates large DGEMMs (e.g. libsci_acc)
 
 ==== 2k. libxc (optional, wider choice of xc functionals) ====
-  * The version 2.2.2 (or later) of libxc needs to be downloaded
+  * The version 4.0.3 (or later) of libxc needs to be downloaded
     (http://www.tddft.org/programs/octopus/wiki/index.php/Libxc) and installed.
     During the installation, the directory $(LIBXC_DIR)/lib and
     $(LIBXC_DIR)/include are created.
-  * Note, the deprecated flags -D__LIBXC2 and -D__LIBXC3 are aliases to -D__LIBXC.
+  * Note, the former deprecated flags -D__LIBXC2 and -D__LIBXC3 are ignored.
   * Add -D__LIBXC to DFLAGS, -I$(LIBXC_DIR)/include to FCFLAGS and
-    -L$(LIBXC_DIR)/lib -lxcf90 -lxc to LIBS.
+    -L$(LIBXC_DIR)/lib -lxcf03 -lxc to LIBS.
 
 ==== 2l. ELPA (optional, improved performance for diagonalization) ====
 Library ELPA for the solution of the eigenvalue problem
Index: arch/Darwin-IntelMacintosh-gfortran.ssmp
===================================================================
--- arch/Darwin-IntelMacintosh-gfortran.ssmp	(revision 18250)
+++ arch/Darwin-IntelMacintosh-gfortran.ssmp	(working copy)
@@ -11,5 +11,5 @@
 LDFLAGS  = $(FCFLAGS) 
 LIBS     = -framework Accelerate \
            -L/opt/local/lib \
-           -lxcf90 -lxc \
+           -lxcf03 -lxc \
            -lderiv -lint
Index: arch/IBM-BGQ-MPI.popt
===================================================================
--- arch/IBM-BGQ-MPI.popt	(revision 18250)
+++ arch/IBM-BGQ-MPI.popt	(working copy)
@@ -14,7 +14,7 @@
 FC       = mpixlf95_r
 LD       = mpixlf95_r
 AR       = ar -r
-LIBXC_INCLUDE=$(HOME)/libxc-2.2.2-install/include
+LIBXC_INCLUDE=$(HOME)/libxc-4.0.4-install/include
 DFLAGS   = -D__FFTW3 -D__parallel -D__SCALAPACK -D__LIBINT -D__LIBXC2 -D__MPI_VERSION=2
 CPPFLAGS = $(DFLAGS) -I$(FFTW3_INCLUDE) -I$(LIBXC_INCLUDE)
 FCFLAGS  = -O3 -qstrict -q64 -qarch=qp -qtune=qp \
@@ -25,6 +25,6 @@
            -L$(FFTW3_LIB) -lfftw3 \
            -L$(SCALAPACK_LIB) -lscalapack \
            -L$(LAPACK_LIB) -llapack \
-           -L$(HOME)/libxc-2.2.2-install/lib -lxcf90 -lxc \
+           -L$(HOME)/libxc-4.0.4-install/lib -lxcf03 -lxc \
            -L/bgsys/local/lib -lesslbg \
            -lmass 
Index: arch/Linux-x86-64-gfortran-regtest.pdbg
===================================================================
--- arch/Linux-x86-64-gfortran-regtest.pdbg	(revision 18250)
+++ arch/Linux-x86-64-gfortran-regtest.pdbg	(working copy)
@@ -12,8 +12,8 @@
 FFTW_LIB   = $(GCC_DIR)/fftw/3.3-gnu-regtest/lib64
 LIBINT_INC = $(GCC_DIR)/libint/1.1.4-default-gnu-regtest/include
 LIBINT_LIB = $(GCC_DIR)/libint/1.1.4-default-gnu-regtest/lib64
-LIBXC_INC  = $(GCC_DIR)/libxc/3.0.0-gnu-regtest/include
-LIBXC_LIB  = $(GCC_DIR)/libxc/3.0.0-gnu-regtest/lib64
+LIBXC_INC  = $(GCC_DIR)/libxc/4.0.4-gnu-regtest/include
+LIBXC_LIB  = $(GCC_DIR)/libxc/4.0.4-gnu-regtest/lib64
 DFLAGS     = -D__ELPA=201605 -D__FFTW3 -D__LIBINT -D__LIBXC -D__MPI_VERSION=3 -D__PLUMED2\
              -D__parallel -D__SCALAPACK
 CPPFLAGS   =
@@ -34,7 +34,7 @@
              $(LIBPATH)/liblapack-gnu-regtest.a\
              $(LIBPATH)/libblas-gnu-regtest.a\
              $(FFTW_LIB)/libfftw3.a\
-             $(LIBXC_LIB)/libxcf90.a\
+             $(LIBXC_LIB)/libxcf03.a\
              $(LIBXC_LIB)/libxc.a\
              $(LIBINT_LIB)/libderiv.a\
              $(LIBINT_LIB)/libint.a
Index: arch/Linux-x86-64-gfortran-regtest.psmp
===================================================================
--- arch/Linux-x86-64-gfortran-regtest.psmp	(revision 18250)
+++ arch/Linux-x86-64-gfortran-regtest.psmp	(working copy)
@@ -12,8 +12,8 @@
 FFTW_LIB   = $(GCC_DIR)/fftw/3.3-gnu-regtest/lib64
 LIBINT_INC = $(GCC_DIR)/libint/1.1.4-default-gnu-regtest/include
 LIBINT_LIB = $(GCC_DIR)/libint/1.1.4-default-gnu-regtest/lib64
-LIBXC_INC  = $(GCC_DIR)/libxc/3.0.0-gnu-regtest/include
-LIBXC_LIB  = $(GCC_DIR)/libxc/3.0.0-gnu-regtest/lib64
+LIBXC_INC  = $(GCC_DIR)/libxc/4.0.4-gnu-regtest/include
+LIBXC_LIB  = $(GCC_DIR)/libxc/4.0.4-gnu-regtest/lib64
 DFLAGS     = -D__ELPA=201605 -D__FFTW3 -D__LIBINT -D__LIBXC -D__MPI_VERSION=3 -D__PLUMED2\
              -D__parallel -D__SCALAPACK
 CPPFLAGS   =
@@ -35,7 +35,7 @@
              $(LIBPATH)/libblas-gnu-regtest.a\
              $(FFTW_LIB)/libfftw3.a\
              $(FFTW_LIB)/libfftw3_threads.a\
-             $(LIBXC_LIB)/libxcf90.a\
+             $(LIBXC_LIB)/libxcf03.a\
              $(LIBXC_LIB)/libxc.a\
              $(LIBINT_LIB)/libderiv.a\
              $(LIBINT_LIB)/libint.a
Index: arch/Linux-x86-64-gfortran-regtest.sdbg
===================================================================
--- arch/Linux-x86-64-gfortran-regtest.sdbg	(revision 18250)
+++ arch/Linux-x86-64-gfortran-regtest.sdbg	(working copy)
@@ -8,8 +8,8 @@
 FFTW_LIB   = $(GCC_DIR)/fftw/3.3-gnu-regtest/lib64
 LIBINT_INC = $(GCC_DIR)/libint/1.1.4-default-gnu-regtest/include
 LIBINT_LIB = $(GCC_DIR)/libint/1.1.4-default-gnu-regtest/lib64
-LIBXC_INC  = $(GCC_DIR)/libxc/3.0.0-gnu-regtest/include
-LIBXC_LIB  = $(GCC_DIR)/libxc/3.0.0-gnu-regtest/lib64
+LIBXC_INC  = $(GCC_DIR)/libxc/4.0.4-gnu-regtest/include
+LIBXC_LIB  = $(GCC_DIR)/libxc/4.0.4-gnu-regtest/lib64
 DFLAGS     = -D__FFTW3 -D__LIBINT -D__LIBXC
 CPPFLAGS   =
 WFLAGS     = -Waliasing -Wampersand -Wc-binding-type -Wconversion\
@@ -25,7 +25,7 @@
 LIBS       = $(LIBPATH)/liblapack-gnu-regtest.a\
              $(LIBPATH)/libblas-gnu-regtest.a\
              $(FFTW_LIB)/libfftw3.a\
-             $(LIBXC_LIB)/libxcf90.a\
+             $(LIBXC_LIB)/libxcf03.a\
              $(LIBXC_LIB)/libxc.a\
              $(LIBINT_LIB)/libderiv.a\
              $(LIBINT_LIB)/libint.a
Index: arch/Linux-x86-64-gfortran-regtest.ssmp
===================================================================
--- arch/Linux-x86-64-gfortran-regtest.ssmp	(revision 18250)
+++ arch/Linux-x86-64-gfortran-regtest.ssmp	(working copy)
@@ -8,8 +8,8 @@
 FFTW_LIB   = $(GCC_DIR)/fftw/3.3-gnu-regtest/lib64
 LIBINT_INC = $(GCC_DIR)/libint/1.1.4-default-gnu-regtest/include
 LIBINT_LIB = $(GCC_DIR)/libint/1.1.4-default-gnu-regtest/lib64
-LIBXC_INC  = $(GCC_DIR)/libxc/3.0.0-gnu-regtest/include
-LIBXC_LIB  = $(GCC_DIR)/libxc/3.0.0-gnu-regtest/lib64
+LIBXC_INC  = $(GCC_DIR)/libxc/4.0.4-gnu-regtest/include
+LIBXC_LIB  = $(GCC_DIR)/libxc/4.0.4-gnu-regtest/lib64
 DFLAGS     = -D__FFTW3 -D__LIBINT -D__LIBXC
 CPPFLAGS   =
 WFLAGS     = -Waliasing -Wampersand -Wc-binding-type -Wconversion\
@@ -26,7 +26,7 @@
              $(LIBPATH)/libblas-gnu-regtest.a\
              $(FFTW_LIB)/libfftw3.a\
              $(FFTW_LIB)/libfftw3_threads.a\
-             $(LIBXC_LIB)/libxcf90.a\
+             $(LIBXC_LIB)/libxcf03.a\
              $(LIBXC_LIB)/libxc.a\
              $(LIBINT_LIB)/libderiv.a\
              $(LIBINT_LIB)/libint.a
Index: arch/Linux-x86-64-gfortran.popt
===================================================================
--- arch/Linux-x86-64-gfortran.popt	(revision 18250)
+++ arch/Linux-x86-64-gfortran.popt	(working copy)
@@ -8,8 +8,8 @@
 FFTW_LIB   = $(GCC_DIR)/fftw/3.3-gnu/lib64
 LIBINT_INC = $(GCC_DIR)/libint/1.1.4-LARGE_L-gnu/include
 LIBINT_LIB = $(GCC_DIR)/libint/1.1.4-LARGE_L-gnu/lib64
-LIBXC_INC  = $(GCC_DIR)/libxc/3.0.0-gnu/include
-LIBXC_LIB  = $(GCC_DIR)/libxc/3.0.0-gnu/lib64
+LIBXC_INC  = $(GCC_DIR)/libxc/4.0.4-gnu/include
+LIBXC_LIB  = $(GCC_DIR)/libxc/4.0.4-gnu/lib64
 DFLAGS     = -D__FFTW3 -D__LIBINT -D__LIBXC -D__MPI_VERSION=3\
              -D__LIBINT_MAX_AM=7 -D__LIBDERIV_MAX_AM1=6 -D__MAX_CONTR=4\
              -D__parallel -D__SCALAPACK
@@ -23,7 +23,7 @@
              $(LIBPATH)/liblapack-gnu.a\
              $(LIBPATH)/libblas-gnu.a\
              $(FFTW_LIB)/libfftw3.a\
-             $(LIBXC_LIB)/libxcf90.a\
+             $(LIBXC_LIB)/libxcf03.a\
              $(LIBXC_LIB)/libxc.a\
              $(LIBINT_LIB)/libderiv.a\
              $(LIBINT_LIB)/libint.a
Index: arch/Linux-x86-64-gfortran.psmp
===================================================================
--- arch/Linux-x86-64-gfortran.psmp	(revision 18250)
+++ arch/Linux-x86-64-gfortran.psmp	(working copy)
@@ -8,8 +8,8 @@
 FFTW_LIB   = $(GCC_DIR)/fftw/3.3-gnu/lib64
 LIBINT_INC = $(GCC_DIR)/libint/1.1.4-LARGE_L-gnu/include
 LIBINT_LIB = $(GCC_DIR)/libint/1.1.4-LARGE_L-gnu/lib64
-LIBXC_INC  = $(GCC_DIR)/libxc/3.0.0-gnu/include
-LIBXC_LIB  = $(GCC_DIR)/libxc/3.0.0-gnu/lib64
+LIBXC_INC  = $(GCC_DIR)/libxc/4.0.4-gnu/include
+LIBXC_LIB  = $(GCC_DIR)/libxc/4.0.4-gnu/lib64
 DFLAGS     = -D__FFTW3 -D__LIBINT -D__LIBXC -D__MPI_VERSION=3\
              -D__LIBINT_MAX_AM=7 -D__LIBDERIV_MAX_AM1=6 -D__MAX_CONTR=4\
              -D__parallel -D__SCALAPACK
@@ -24,7 +24,7 @@
              $(LIBPATH)/libblas-gnu.a\
              $(FFTW_LIB)/libfftw3.a\
              $(FFTW_LIB)/libfftw3_threads.a\
-             $(LIBXC_LIB)/libxcf90.a\
+             $(LIBXC_LIB)/libxcf03.a\
              $(LIBXC_LIB)/libxc.a\
              $(LIBINT_LIB)/libderiv.a\
              $(LIBINT_LIB)/libint.a
Index: arch/Linux-x86-64-gfortran.sdbg
===================================================================
--- arch/Linux-x86-64-gfortran.sdbg	(revision 18250)
+++ arch/Linux-x86-64-gfortran.sdbg	(working copy)
@@ -8,8 +8,8 @@
 FFTW_LIB   = $(GCC_DIR)/fftw/3.3-gnu-regtest/lib64
 LIBINT_INC = $(GCC_DIR)/libint/1.1.4-default-gnu-regtest/include
 LIBINT_LIB = $(GCC_DIR)/libint/1.1.4-default-gnu-regtest/lib64
-LIBXC_INC  = $(GCC_DIR)/libxc/2.2.2-gnu-regtest/include
-LIBXC_LIB  = $(GCC_DIR)/libxc/2.2.2-gnu-regtest/lib64
+LIBXC_INC  = $(GCC_DIR)/libxc/4.0.4-gnu-regtest/include
+LIBXC_LIB  = $(GCC_DIR)/libxc/4.0.4-gnu-regtest/lib64
 DFLAGS     = -D__FFTW3 -D__LIBINT -D__LIBXC2
 CPPFLAGS   =
 WFLAGS     = -Waliasing -Wampersand -Wc-binding-type -Wconversion\
@@ -24,7 +24,7 @@
 LIBS       = $(LIBPATH)/liblapack-gnu-regtest.a\
              $(LIBPATH)/libblas-gnu-regtest.a\
              $(FFTW_LIB)/libfftw3.a\
-             $(LIBXC_LIB)/libxcf90.a\
+             $(LIBXC_LIB)/libxcf03.a\
              $(LIBXC_LIB)/libxc.a\
              $(LIBINT_LIB)/libderiv.a\
              $(LIBINT_LIB)/libint.a
Index: arch/Linux-x86-64-gfortran.sopt
===================================================================
--- arch/Linux-x86-64-gfortran.sopt	(revision 18250)
+++ arch/Linux-x86-64-gfortran.sopt	(working copy)
@@ -8,8 +8,8 @@
 FFTW_LIB   = $(GCC_DIR)/fftw/3.3-gnu/lib64
 LIBINT_INC = $(GCC_DIR)/libint/1.1.4-LARGE_L-gnu/include
 LIBINT_LIB = $(GCC_DIR)/libint/1.1.4-LARGE_L-gnu/lib64
-LIBXC_INC  = $(GCC_DIR)/libxc/3.0.0-gnu/include
-LIBXC_LIB  = $(GCC_DIR)/libxc/3.0.0-gnu/lib64
+LIBXC_INC  = $(GCC_DIR)/libxc/4.0.4-gnu/include
+LIBXC_LIB  = $(GCC_DIR)/libxc/4.0.4-gnu/lib64
 DFLAGS     = -D__FFTW3 -D__LIBINT -D__LIBXC\
              -D__LIBINT_MAX_AM=7 -D__LIBDERIV_MAX_AM1=6 -D__MAX_CONTR=4
 CPPFLAGS   = 
@@ -21,7 +21,7 @@
 LIBS       = $(LIBPATH)/liblapack-gnu.a\
              $(LIBPATH)/libblas-gnu.a\
              $(FFTW_LIB)/libfftw3.a\
-             $(LIBXC_LIB)/libxcf90.a\
+             $(LIBXC_LIB)/libxcf03.a\
              $(LIBXC_LIB)/libxc.a\
              $(LIBINT_LIB)/libderiv.a\
              $(LIBINT_LIB)/libint.a\
Index: arch/Linux-x86-64-gfortran.ssmp
===================================================================
--- arch/Linux-x86-64-gfortran.ssmp	(revision 18250)
+++ arch/Linux-x86-64-gfortran.ssmp	(working copy)
@@ -8,8 +8,8 @@
 FFTW_LIB   = $(GCC_DIR)/fftw/3.3-gnu/lib64
 LIBINT_INC = $(GCC_DIR)/libint/1.1.4-LARGE_L-gnu/include
 LIBINT_LIB = $(GCC_DIR)/libint/1.1.4-LARGE_L-gnu/lib64
-LIBXC_INC  = $(GCC_DIR)/libxc/3.0.0-gnu/include
-LIBXC_LIB  = $(GCC_DIR)/libxc/3.0.0-gnu/lib64
+LIBXC_INC  = $(GCC_DIR)/libxc/4.0.4-gnu/include
+LIBXC_LIB  = $(GCC_DIR)/libxc/4.0.4-gnu/lib64
 DFLAGS     = -D__FFTW3 -D__LIBINT -D__LIBXC\
              -D__LIBINT_MAX_AM=7 -D__LIBDERIV_MAX_AM1=6 -D__MAX_CONTR=4
 CPPFLAGS   = 
@@ -22,7 +22,7 @@
              $(LIBPATH)/libblas-gnu.a\
              $(FFTW_LIB)/libfftw3.a\
              $(FFTW_LIB)/libfftw3_threads.a\
-             $(LIBXC_LIB)/libxcf90.a\
+             $(LIBXC_LIB)/libxcf03.a\
              $(LIBXC_LIB)/libxc.a\
              $(LIBINT_LIB)/libderiv.a\
              $(LIBINT_LIB)/libint.a
Index: arch/Linux-x86-64-intel-mic.psmp
===================================================================
--- arch/Linux-x86-64-intel-mic.psmp	(revision 18250)
+++ arch/Linux-x86-64-intel-mic.psmp	(working copy)
@@ -155,7 +155,7 @@
 ifneq (,$(LIBXCROOT))
   DFLAGS  += -D__LIBXC2
   IFLAGS  += -I$(LIBXCROOT)/include
-  LIBS    += $(LIBXCROOT)/lib/libxcf90.a $(LIBXCROOT)/lib/libxc.a
+  LIBS    += $(LIBXCROOT)/lib/libxcf03.a $(LIBXCROOT)/lib/libxc.a
 endif
 
 ifneq (,$(LIBXSTREAMROOT))
Index: src/atom_output.F
===================================================================
--- src/atom_output.F	(revision 18250)
+++ src/atom_output.F	(working copy)
@@ -1,6 +1,6 @@
 !--------------------------------------------------------------------------------------------------!
 !   CP2K: A general program to perform molecular dynamics simulations                              !
-!   Copyright (C) 2000 - 2017  CP2K developers group                                               !
+!   Copyright (C) 2000 - 2018  CP2K developers group                                               !
 !--------------------------------------------------------------------------------------------------!
 
 ! **************************************************************************************************
@@ -22,8 +22,11 @@
         do_rhf_atom, do_rks_atom, do_rohf_atom, do_sczoramp_atom, do_uhf_atom, do_uks_atom, &
         do_zoramp_atom, poly_conf, xc_none
    USE input_cp2k_check,                ONLY: xc_functionals_expand
-   USE input_section_types,             ONLY: section_vals_get_subs_vals,&
+   USE input_section_types,             ONLY: section_vals_duplicate,&
+                                              section_vals_get,&
+                                              section_vals_get_subs_vals,&
                                               section_vals_get_subs_vals2,&
+                                              section_vals_release,&
                                               section_vals_type,&
                                               section_vals_val_get
    USE kinds,                           ONLY: default_string_length,&
@@ -469,10 +472,11 @@
       CHARACTER(len=10*default_string_length)            :: reference
       CHARACTER(len=160)                                 :: shortform
       CHARACTER(len=20)                                  :: tmpStr
-      CHARACTER(len=80), DIMENSION(:), POINTER           :: func_name
-      INTEGER                                            :: ifun, ifunc_name, il, meth, myfun, reltyp
+      INTEGER                                            :: i_rep, ifun, il, meth, myfun, n_rep, &
+                                                            reltyp
       LOGICAL                                            :: lsd
-      TYPE(section_vals_type), POINTER                   :: xc_fun, xc_fun_section, xc_section
+      TYPE(section_vals_type), POINTER                   :: libxc_fun, xc_fun, xc_fun_section, &
+                                                            xc_section
 
       NULLIFY (xc_fun, xc_fun_section, xc_section)
 
@@ -567,20 +571,24 @@
                ifun = ifun+1
                xc_fun => section_vals_get_subs_vals2(xc_fun_section, i_section=ifun)
                IF (.NOT. ASSOCIATED(xc_fun)) EXIT
-               CALL xc_functional_get_info(xc_fun, lsd=lsd, reference=reference, &
-                                           shortform=shortform, ifunc_name=1)
-               IF (TRIM(xc_fun%section%name) == "LIBXC") THEN
-                  CALL libxc_version_info(tmpStr)
-                  WRITE (iw, fmt="(A,A,A)") ' FUNCTIONAL| LIBXC Vers. ', TRIM(tmpStr(1:5)), &
-                     ' (Marques, Oliveira, Burnus, CPC 183, 2272 (2012))'
-                  WRITE (iw, fmt="(' FUNCTIONAL| ',a,':')") TRIM(shortform)
+               IF (TRIM(xc_fun%section%name) /= "LIBXC") THEN
+                  CALL xc_functional_get_info(xc_fun, lsd=lsd, reference=reference, shortform=shortform)
+                  WRITE (iw, fmt="(' FUNCTIONAL| ',a,':')") &
+                     TRIM(xc_fun%section%name)
                   DO il = 1, LEN_TRIM(reference), 67
                      WRITE (iw, fmt="(' FUNCTIONAL| ',a67)") reference(il:)
                   END DO
-                  CALL section_vals_val_get(xc_fun, "functional", c_vals=func_name)
-                  DO ifunc_name = 2, SIZE(func_name)
-                     CALL xc_functional_get_info(xc_fun, lsd=lsd, reference=reference, &
-                                                 shortform=shortform, ifunc_name=ifunc_name)
+               ELSE
+                  ! LIBXC is the only repeatable functional section - for each we need
+                  ! NOT the single values, but the whole section_vals_type independently
+                  CALL section_vals_get(xc_fun, n_repetition=n_rep)
+                  DO i_rep = 1, n_rep
+                     NULLIFY (libxc_fun)
+                     CALL section_vals_duplicate(xc_fun, libxc_fun, i_rep_start=i_rep, i_rep_end=i_rep)
+                     IF (.NOT. ASSOCIATED(libxc_fun)) EXIT
+                     CALL xc_functional_get_info(libxc_fun, lsd=lsd, reference=reference, shortform=shortform)
+                     CALL section_vals_release(libxc_fun)
+                     CALL libxc_version_info(tmpStr)
                      WRITE (iw, fmt="(A,A,A)") ' FUNCTIONAL| LIBXC Vers. ', TRIM(tmpStr(1:5)), &
                         ' (Marques, Oliveira, Burnus, CPC 183, 2272 (2012))'
                      WRITE (iw, fmt="(' FUNCTIONAL| ',a,':')") TRIM(shortform)
@@ -588,12 +596,6 @@
                         WRITE (iw, fmt="(' FUNCTIONAL| ',a67)") reference(il:)
                      END DO
                   END DO
-               ELSE
-                  WRITE (iw, fmt="(' FUNCTIONAL| ',a,':')") &
-                     TRIM(xc_fun%section%name)
-                  DO il = 1, LEN_TRIM(reference), 67
-                     WRITE (iw, fmt="(' FUNCTIONAL| ',a67)") reference(il:)
-                  END DO
                END IF
             END DO
          END IF
Index: src/common/bibliography.F
===================================================================
--- src/common/bibliography.F	(revision 18250)
+++ src/common/bibliography.F	(working copy)
@@ -1,6 +1,6 @@
 !--------------------------------------------------------------------------------------------------!
 !   CP2K: A general program to perform molecular dynamics simulations                              !
-!   Copyright (C) 2000 - 2017  CP2K developers group                                               !
+!   Copyright (C) 2000 - 2018  CP2K developers group                                               !
 !--------------------------------------------------------------------------------------------------!
 
 ! **************************************************************************************************
@@ -80,8 +80,8 @@
                             Gilbert2008, Schonherr2014, Ceriotti2014, BaniHashemian2016, &
                             Kapil2016, Heinzmann1976, Ehrhardt1985, Rybkin2016, West2006, &
                             Bates2013, Andermatt2016, Zhu2016, Schuett2016, Lu2004, &
-                            Becke1988b, Migliore2009, Mavros2015, Holmberg2017, Marek2014
-
+                            Becke1988b, Migliore2009, Mavros2015, Holmberg2017, Marek2014, &
+                            Lehtola2018
 CONTAINS
 
 ! **************************************************************************************************
@@ -2100,6 +2100,28 @@
                          "ER"), &
                          DOI="10.1016/j.cpc.2012.05.007")
 
+      CALL add_reference(key=Lehtola2018, ISI_record=s2a( &
+                         "AU Lehtola, S", &
+                         "   Steigemann, C", &
+                         "   Oliveira, MJT", &
+                         "   Marques, MAL", &
+                         "AF Lehtola, Susi", &
+                         "   Steigemann, Conrad", &
+                         "   Oliveira, Micael J. T.", &
+                         "   Marques, Miguel A. L.", &
+                         "TI Recent developments in libxc - A comprehensive library of functionals", &
+                         "   for density functional theory", &
+                         "SO SoftwareX", &
+                         "SN 2352-7110", &
+                         "PD JAN", &
+                         "PY 2018", &
+                         "VL 7", &
+                         "BP 1", &
+                         "EP 5", &
+                         "DI 10.1016/j.softx.2017.11.002", &
+                         "ER"), &
+                         DOI="10.1016/j.softx.2017.11.002")
+
       CALL add_reference(key=Jones2011, ISI_record=s2a( &
                          "AU Jones, Andrew", &
                          "   Leimkuhler, Ben", &
Index: src/cp2k_info.F
===================================================================
--- src/cp2k_info.F	(revision 18250)
+++ src/cp2k_info.F	(working copy)
@@ -1,6 +1,6 @@
 !--------------------------------------------------------------------------------------------------!
 !   CP2K: A general program to perform molecular dynamics simulations                              !
-!   Copyright (C) 2000 - 2017  CP2K developers group                                               !
+!   Copyright (C) 2000 - 2018  CP2K developers group                                               !
 !--------------------------------------------------------------------------------------------------!
 
 ! **************************************************************************************************
@@ -102,9 +102,6 @@
 #if defined(__FFTW3)
       flags = TRIM(flags)//" fftw3"
 #endif
-#if defined(__LIBXC2) || defined(__LIBXC3)
-#define __LIBXC
-#endif
 #if defined(__LIBXC)
       flags = TRIM(flags)//" libxc"
 #endif
@@ -295,7 +292,7 @@
       WRITE (iunit, '(T2,A)') '!   Copyright (C) 2004, 2005, 2006, 2007  CP2K developers group               !'
       WRITE (iunit, '(T2,A)') '!   Copyright (C) 2008, 2009, 2010, 2011  CP2K developers group               !'
       WRITE (iunit, '(T2,A)') '!   Copyright (C) 2012, 2013, 2014, 2015  CP2K developers group               !'
-      WRITE (iunit, '(T2,A)') '!   Copyright (C) 2016                    CP2K developers group               !'
+      WRITE (iunit, '(T2,A)') '!   Copyright (C) 2016, 2017, 2018        CP2K developers group               !'
       WRITE (iunit, '(T2,A)') '!                                                                             !'
       WRITE (iunit, '(T2,A)') '!   This program is free software; you can redistribute it and/or modify      !'
       WRITE (iunit, '(T2,A)') '!   it under the terms of the GNU General Public License as published by      !'
Index: src/input_cp2k_xc.F
===================================================================
--- src/input_cp2k_xc.F	(revision 18250)
+++ src/input_cp2k_xc.F	(working copy)
@@ -1,6 +1,6 @@
 !--------------------------------------------------------------------------------------------------!
 !   CP2K: A general program to perform molecular dynamics simulations                              !
-!   Copyright (C) 2000 - 2017  CP2K developers group                                               !
+!   Copyright (C) 2000 - 2018  CP2K developers group                                               !
 !--------------------------------------------------------------------------------------------------!
 
 ! **************************************************************************************************
@@ -12,8 +12,8 @@
 MODULE input_cp2k_xc
    USE bibliography,                    ONLY: &
         Becke1988, Becke1997, BeckeRoussel1989, Goedecker1996, Grimme2006, Grimme2010, Grimme2011, &
-        Heyd2004, Lee1988, Marques2012, Ortiz1994, Perdew1981, Perdew1996, Perdew2008, &
-        Proynov2007, Tao2003, Tran2013, Vosko1980, Wellendorff2012, Zhang1998
+        Heyd2004, Lee1988, Lehtola2018, Marques2012, Ortiz1994, Perdew1981, Perdew1996, &
+        Perdew2008, Proynov2007, Tao2003, Tran2013, Vosko1980, Wellendorff2012, Zhang1998
    USE cp_output_handling,              ONLY: add_last_numeric,&
                                               cp_print_key_section_create,&
                                               high_print_level
@@ -220,7 +220,7 @@
 
       CALL section_create(subsection, name="HCTH", &
                           description="Uses the HCTH class of functionals", &
-                          n_keywords=0, n_subsections=0, repeats=.TRUE.)
+                          n_keywords=0, n_subsections=0, repeats=.FALSE.)
       CALL keyword_create(keyword, name="PARAMETER_SET", &
                           description="Which version of the parameters should be used", &
                           usage="PARAMETER_SET 407", &
@@ -270,14 +270,14 @@
 
       CALL create_libxc_section(subsection, "LIBXC", &
                                 "Uses functionals from LIBXC, see also "// &
-                                "http://www.tddft.org/programs/octopus/wiki/index.php/Libxc_functionals ", &
-                                "FUNCTIONAL GGA_X_PBE GGA_C_PBE")
+                                "https://gitlab.com/libxc/libxc/wikis/Functionals-list-4.0.4", &
+                                "FUNCTIONAL GGA_X_PBE")
       CALL section_add_subsection(section, subsection)
       CALL section_release(subsection)
 
       CALL create_libxc_section(subsection, "KE_LIBXC", &
                                 "To be used for KG runs. Uses kinetic energy functionals from LIBXC, "// &
-                                "see also http://www.tddft.org/programs/octopus/wiki/index.php/Libxc_functionals ", &
+                                "https://gitlab.com/libxc/libxc/wikis/Functionals-list-4.0.4", &
                                 "FUNCTIONAL GGA_K_LLP")
       CALL section_add_subsection(section, subsection)
       CALL section_release(subsection)
@@ -747,30 +747,31 @@
       CPASSERT(name == "LIBXC" .OR. name == "KE_LIBXC")
       NULLIFY (keyword)
       CALL section_create(section, name, description, &
-                          n_keywords=3, n_subsections=0, repeats=.FALSE., &
-                          citations=(/Marques2012/))
+                          n_keywords=3, n_subsections=0, repeats=.TRUE., &
+                          citations=(/Marques2012, Lehtola2018/))
       CALL keyword_create(keyword, "_SECTION_PARAMETERS_", &
-                          description="activates the functional", &
+                          description="activates functionals from libxc library", &
                           lone_keyword_l_val=.TRUE., default_l_val=.FALSE.)
       CALL section_add_keyword(section, keyword)
       CALL keyword_release(keyword)
       CALL keyword_create(keyword, name="FUNCTIONAL", &
-                          description="names of the functionals, see also "// &
-                          "http://www.tddft.org/programs/octopus/wiki/index.php/Libxc_functionals ."// &
+                          description="name of the functional, see also "// &
+                          "https://gitlab.com/libxc/libxc/wikis/Functionals-list-4.0.4 "// &
                           "The precise list of available functionals depends on "// &
-                          "the version of libxc interfaced (currently 2.2.2).", &
+                          "the version of libxc interfaced (currently 4.0.4)", &
                           usage=usage, type_of_var=char_t, n_var=-1)
       CALL section_add_keyword(section, keyword)
       CALL keyword_release(keyword)
       CALL keyword_create(keyword, name="SCALE", &
-                          description="scaling factors of the functionals", &
-                          usage="SCALE 1.0 1.0", type_of_var=real_t, &
-                          default_r_vals=(/1.0_dp/), n_var=-1)
+                          description="scaling factors for the functional", &
+                          usage="SCALE 0.8", type_of_var=real_t, &
+                          default_r_val=1.0_dp)
       CALL section_add_keyword(section, keyword)
       CALL keyword_release(keyword)
       CALL keyword_create(keyword, name="PARAMETERS", &
-                          description="parameters of the functionals", &
-                          type_of_var=real_t, default_r_vals=(/1e20_dp/), n_var=-1)
+                          description="list of external parameters for the functional", &
+                          usage="PARAMETERS 0.3 [0.5 [1.4]]", type_of_var=real_t, &
+                          default_r_vals=(/HUGE(0.0_dp)/), n_var=-1)
       CALL section_add_keyword(section, keyword)
       CALL keyword_release(keyword)
    END SUBROUTINE
